//
//  QuotesViewController.swift
//  Quotes
//
//  Created by Bart Jacobs on 07/11/2018.
//  Copyright © 2018 Cocoacasts. All rights reserved.
//

import UIKit

class QuotesViewController: UITableViewController {

    // MARK: - Properties
    
    private lazy var quotes: [String] = {
        return [
            "Life is what happens when you're busy making other plans. - John Lennon",
            "You only live once, but if you do it right, once is enough. - Mae West",
            "If you set your goals ridiculously high and it's a failure, you will fail above everyone else's success. - James Cameron",
            "If you want to live a happy life, tie it to a goal, not to people or things. - Albert Einstein",
            "You miss 100 percent of the shots you never take. - Wayne Gretzky",
            "Every child is an artist, the problem is staying an artist when you grow up. - Pablo Picasso",
            "What you do speaks so loudly that I cannot hear what you say. - Ralph Waldo Emerson",
            "The journey of a thousand miles begins with one step. - Lao Tzu",
            "I don't focus on what I'm up against. I focus on my goals and I try to ignore the rest. - Venus Williams",
            "When it is obvious that the goals cannot be reached, don't adjust the goals, adjust the action steps. - Confucius",
            "The game has its ups and downs, but you can never lose focus of your individual goals and you can't let yourself be beat because of lack of effort. - Michael Jordan",
            "Great things in business are never done by one person. They're done by a team of people. - Steve Jobs",
            "Success is a lousy teacher. It seduces smart people into thinking they can't lose. - Bill Gates"
        ]
    }()
    
    // MARK: - Table View Data Source
    
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return quotes.count
    }
    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        guard let cell = tableView.dequeueReusableCell(withIdentifier: "QuoteTableViewCell", for: indexPath) as? QuoteTableViewCell else {
            fatalError("Unable to Dequeue Quote Table View Cell")
        }
        
        // Configure Cell
        cell.titleLabel.text = quotes[indexPath.row]
        
        return cell
    }
    
    // MARK: - Table View Delegate
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        tableView.deselectRow(at: indexPath, animated: true)
        
        // Initialize Quote View Controller
        guard let quoteViewController = UIStoryboard(name: "Main", bundle: .main).instantiateViewController(withIdentifier: "QuoteViewController") as? QuoteViewController else {
            return
        }
        
        // Fetch Quote
        let quote = quotes[indexPath.row]
        
        // Configure Quote View Controller
        quoteViewController.quote = quote
        
        // Present Quote View Controller
        present(quoteViewController, animated: true)
    }
    
}
